<template lang="pug">
label.drop
	input( type="file" multiple @input='onDrop($event, "input")' )
	slot
</template>

<script setup>
import { ref } from "vue"
import { useI18n } from "vue-i18n"
import { useToast } from "vue-toastification"

const props = defineProps({
	modelValue: {
		type: Array,
		default: () => []
	},
	validation: {
		type: String,
		default: ""
	}
})

const emit = defineEmits([ "update:modelValue" ])
const { t } = useI18n()
const toast = useToast()

const active = ref(false)

const getExt = name => {
	var parts = name.split('.')
	return parts[parts.length - 1]
}

const isImage = name => {
	const ext = getExt(name)
	return [
		"jpg",
		"png",
		"webp" 
	].includes(ext)
}

const validate = (files, fn) => {
	const invalid = []
	
	for (let { name } of files) {
		if (!fn(name)) return true
	}
	return false
}

const onDrop = (e, type = "drop") => {
	active.value = false

	let data = type == "drop" ? e.dataTransfer.files : Object.keys(e.target.files).map(prop => e.target.files[prop])
	
	data = [
		...props.modelValue,
		...data
	]

	if (data.length > 10) {
		toast.warning(t("default.image_count"))
		// data.length = 10
		return
	}

	switch (props.validation) {
		case "images":
			const hasInvalid = validate(data, isImage)
			if (hasInvalid) return toast.error(t("default.image_validate"))
			break;
	}

	emit("update:modelValue", data)
}
</script>

<style lang="scss" scoped>
input { display: none; }

.drop {
	display: block;
	position: relative;
	&-active {
		&::after {
			font-size: .875remrem;
			color: $grey;
			font-weight: 700;
			content: "Перетащите файлы сюда...";
			display: flex;
			align-items: center;
			justify-content: center;
			background: $grey-light;
			border: 4px dashed $grey;
			border-radius: 4px;
			position: absolute;
			top: 0;
			right: 0;
			bottom: 0;
			left: 0;
			z-index: 2;
		}
	}
}
</style>